<?php

namespace xenarabia\ThreadsStamp\XF\Pub\Controller;

use Laminas\Validator\File\Exists;
use XF\Mvc\FormAction;
use XF\Mvc\ParameterBag;
use XF\Mvc\Reply\View;
use XF\Pub\Controller\AbstractController;



class Thread extends XFCP_Thread{

    public function actionStampThread(ParameterBag $params)
    {
        // \XF::dump($params);
        $stamps = $this->finder('xenarabia\ThreadsStamp:StampsEntity')->fetch();
        $page = $this->filterPage($params->page);
        $perPage = 20;
        $stamps = $this->getAllstamps($page, $perPage);
        $thread = $this->assertViewableThread($params->thread_id, $this->getThreadViewExtraWith());
        $viewParams = [
            'stamps' => $stamps->fetch(),
            'page'     => $page,
            'thread'        => $thread,
            'perPage' => $perPage,
            'total'        => $stamps->total()
        ];
        return $this->view('xenarabia\ThreadsStamp:ThreadsStamp\list', 'stamps_list', $viewParams);
    }

    public function actionDOStampThread(ParameterBag $params)
    {
       $s_id = $this->filter('s_id', 'int');
       $thread = $this->em()->find('XF:Thread', $params->thread_id);
       $updateThread = \XF::db()->update('xf_thread', ['xa_stamp_id' => $s_id], 'thread_id = ?', [$params->thread_id]);
       return $this->redirect($this->buildLink('threads', $thread), \XF::phrase('ts_thread_has_been_stamped'));
    }

    public function actionRemoveStampThread(ParameterBag $params)
    {
       $s_id = $this->filter('s_id', 'int');
       $thread = $this->em()->find('XF:Thread', $params->thread_id);
       $updateThread = \XF::db()->update('xf_thread', ['xa_stamp_id' => 0], 'thread_id = ?', [$params->thread_id]);
       return $this->redirect($this->buildLink('threads', $thread), \XF::phrase('ts_thread_has_been_stamped'));
    }

    protected function getAllStamps($page, $perPage)
    {
        $repo = $this->finder('xenarabia\ThreadsStamp:StampsEntity');
        $finder = $repo->order('s_id', 'ASC')
        ->limitByPage($page, $perPage);
        return $finder;
    }

}